#ifndef SETTINGSDIALOGAPPARENCE_H
#define SETTINGSDIALOGAPPARENCE_H
#include "Tools/menuXP.h"
#include "Tools/ButtonXP.h"
#include "Tools/ComboBoxXP.h"

// Bote de dialogue CSettingApparence

class CSettingsDialogApparence : public CPropertyPage {
        DECLARE_DYNAMIC(CSettingsDialogApparence)

    public:
        CSettingsDialogApparence();
        virtual ~CSettingsDialogApparence();

        BOOL showGradient;
        BOOL showToolTip;
        COLORREF startColor;
        COLORREF endColor;
        CString toolTipText;
        int toolTipTime;

        CButtonXP m_btnStartColor;
        CButtonXP m_btnEndColor;

    protected:
        afx_msg void OnOK();
        virtual void DoDataExchange(CDataExchange *pDX);  // Prise en charge DDX/DDV
        virtual BOOL OnInitDialog();
        void OnStartColor();
        void OnEndColor();
        void DrawGradientSample();
        void OnPaint();

        DECLARE_MESSAGE_MAP()
        DECLARE_MENUXP()
};

#endif